//+------------------------------------------------------------------+
//|                                              Market Sessions.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property link      " Modified by cja "

#property indicator_chart_window

extern int    NumberOfDays  = 10;       
extern string US_Open       = "15:00";  
extern string US_Close        = "23:59";  
extern color  US_Color_1      = DarkBlue;//US
extern string Europe_Open       = "08:00";
extern string Europe_Close        = "19:00";
extern color  Europe_Color_2      = Maroon;//Europe
extern string Asia_Open       = "00:00";
extern string Asia_Close        = "12:00";
extern color  Asia_Color_3      = DarkGreen;//Asia

extern bool   Panel_or_Line      = false;
extern bool   Labels      = true;
//extern bool       = true; // true = rectangles follow hi/low // false = full length colors 
double HighLow = true; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {

IndicatorShortName("MktSession");
  DeleteObjects();
  for (int i=0; i<NumberOfDays; i++) {
    CreateObjects("MktSession1"+i, US_Color_1);
    CreateObjects("MktSession2"+i, Europe_Color_2);
    CreateObjects("MktSession3"+i, Asia_Color_3);
    
  }
  
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
ObjectDelete("MKS1");
ObjectDelete("MKS2");
ObjectDelete("MKS3");
 
  DeleteObjects();
  }

void CreateObjects(string no, color cl) {
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_WIDTH,3);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK,  Panel_or_Line );
}

void DeleteObjects() {
  for (int i=0; i<NumberOfDays; i++) {
    ObjectDelete("MktSession1"+i);
    ObjectDelete("MktSession2"+i);
    ObjectDelete("MktSession3"+i);
   
  }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {

if (Labels==true)
{
   drawLabel("MKS1"," ASIAN Market:  ",12,Green,5,35,"Arial Narrow Bold");  
   drawLabel2("MKS2"," EUROPEAN Market:  ",12,Crimson,5,35,"Arial Narrow Bold"); 
   drawLabel3("MKS3"," US Market:  ",12,DodgerBlue,5,35,"Arial Narrow Bold");
  }
   
   ObjectsRedraw();

               
  datetime dt=CurTime();

  for (int i=0; i<NumberOfDays; i++) {
    DrawObjects(dt, "MktSession1"+i, US_Open, US_Close);
    DrawObjects(dt, "MktSession2"+i, Europe_Open, Europe_Close);
    DrawObjects(dt, "MktSession3"+i, Asia_Open, Asia_Close);
    
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
}

void DrawObjects(datetime dt, string no, string tb, string te) {
  datetime time1, time2;
  double   p1, p2;
  int      b1, b2;

  time1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  time2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, time1);
  b2=iBarShift(NULL, 0, time2);
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  if (!HighLow) {p1=0; p2=2*p2;}
  ObjectSet(no, OBJPROP_TIME1 , time1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , time2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
}

datetime decDateTradeDay (datetime dt) {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+
 
void drawLabel(string id, string text,int fsize, color fcolor,int x,int y,string font,int window = 0)

     { if(ObjectFind(id)==-1)
         {
         ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 4);
        ObjectSet(id, OBJPROP_XDISTANCE, 220);
        ObjectSet(id, OBJPROP_YDISTANCE, 0);
        }
        
     
  }
  void drawLabel2(string id, string text,int fsize, color fcolor,int a,int z,string font,int window = 0)

     { if(ObjectFind(id)==-1)
         {
         ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 4);
        ObjectSet(id, OBJPROP_XDISTANCE, 350);
        ObjectSet(id, OBJPROP_YDISTANCE, 0);
        }
        
     
  }
  void drawLabel3(string id, string text,int fsize, color fcolor,int b,int w,string font,int window = 0)

     { if(ObjectFind(id)==-1)
         {
         ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 4);
        ObjectSet(id, OBJPROP_XDISTANCE, 510);
        ObjectSet(id, OBJPROP_YDISTANCE, 0);
        }
        
     
 
  }


